unit NormalProbPlot;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Basic_Form, StdCtrls, ExtCtrls, TeeProcs, TeEngine, Chart, TeeTools,
  StatAxisLabelTool, MtxVec, Series, StatSeries, TeCanvas, TeePenDlg,
  Math387;

type
  TfrmNormalProb = class(TfrmBasic)
    Panel2: TPanel;
    Button1: TButton;
    Chart1: TChart;
    Button2: TButton;
    ChartTool1: TStatAxisLabelTool;
    ButtonPen1: TButtonPen;
    Series1: TStatProbSeries;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    Data,X,Y: TVec;
    MinX,MaxX, MinY, MaxY: TSample;
    procedure Recalc;
  public
    { Public declarations }
  end;

var
  frmNormalProb: TfrmNormalProb;

implementation

Uses EditChar, MtxVecTee;
{$R *.DFM}

procedure TfrmNormalProb.Button2Click(Sender: TObject);
begin
  EditSeries(Self,Series1);
end;

procedure TfrmNormalProb.Button1Click(Sender: TObject);
var ResStr: String;
    Mu,Sigma: TSample;
begin
  ResStr := InputBox('Data size','Number of points to be generated : ','100');
  try
    Data.Size(StrToInt(ResStr));
  except
    Data.Size(100);
  end;
  ResStr := InputBox('Mu','Mu (average) : ',FormatFloat('0.00',3.5));
  try
    Mu := StrToFloat(ResStr);
  except
    Mu := 3.5;
  end;
  ResStr := InputBox('Sigma','Sigma (Std.dev.) : ',FormatFloat('0.00',0.1));
  try
    Sigma := StrToFloat(ResStr);
  except
    Sigma := 0.1;
  end;
  Data.RandGauss(Mu,Sigma);
  Recalc;
end;

procedure TfrmNormalProb.FormCreate(Sender: TObject);
begin
  inherited;
  ButtonPen1.LinkPen(Series1.SlopePen);
  With Memo1.Lines do
  begin
    Clear;
    Add('Normal probability plot');
    Add(chr(13));
    Add('The TStatSpecialSeries can be used to plot the Normal probability Chart. '+
        'Most properties can be customized (click the "Edit" button)');
  end;
  Data := TVec.Create;
  X := TVec.Create;
  Y := TVec.Create;
  Data.Size(100);
  Data.RandGauss(3.5,0.1);
  Recalc;
end;

procedure TfrmNormalProb.FormDestroy(Sender: TObject);
begin
  Data.Destroy;
  X.Destroy;
  Y.Destroy;
  inherited;
end;

procedure TfrmNormalProb.Recalc;
begin
  StatNormalPlot(Data,X,Y,MinX,MaxX,MinY,MaxY,false);
  Series1.MinX := MinX;
  Series1.MaxX := MaxX;
  Series1.MinY := MinY;
  Series1.MaxY := MaxY;
  DrawValues(X,Y,Series1);
end;

initialization
  RegisterClass(TfrmNormalProb);

end.
