unit QQPlot;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Basic_Form, TeEngine, TeeTools, StatAxisLabelTool, Series, StatSeries,
  TeeProcs, Chart, StdCtrls, ExtCtrls, TeCanvas, TeePenDlg, MtxVec, Math387;

type
  TfrmQQPlot = class(TfrmBasic)
    Panel2: TPanel;
    Chart1: TChart;
    ChartTool1: TStatAxisLabelTool;
    Button1: TButton;
    ButtonPen1: TButtonPen;
    Button2: TButton;
    Series1: TStatProbSeries;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    XData,YData: TVec;
    X,Y: TVec;
    minX,MaxX,MinY,MaxY: TSample;
    procedure Recalc;
  public
    { Public declarations }
  end;

var
  frmQQPlot: TfrmQQPlot;

implementation
{$R *.DFM}

Uses EditChar, StatAxisLabelToolEdit, MtxVecTee;

procedure TfrmQQPlot.Button1Click(Sender: TObject);
begin
  EditSeries(Self,Series1);
end;

procedure TfrmQQPlot.FormCreate(Sender: TObject);
begin
  inherited;
  With Memo1.Lines do
  begin
    Clear;
    Add('The Quantile-Quantile plot');
    Add(chr(13));
    Add('The TStatSpecialSeries can be used to plot the Quantile-Quantile Chart. '+
        'Most properties can be customized (click the "Edit" button)');
  end;
  ButtonPen1.LinkPen(Series1.SlopePen);
  XData := TVec.Create;
  YData := TVec.Create;
  X := TVec.Create;
  Y := TVec.Create;
  With XData do
  begin
    Size(100);
    RandGauss(5,0.1);
  end;
  With YData do
  begin
    Size(100);
    RandGauss(3,0.3);
  end;
  Recalc;
end;

procedure TfrmQQPlot.Button2Click(Sender: TObject);
var ResStr: String;
    Mu,Sigma: TSample;
begin
  ResStr := InputBox('Data size','Number of points to be generated : ','100');
  try
    XData.Size(StrToInt(ResStr));
  except
    XData.Size(100);
  end;
  YData.Size(XData);
  ResStr := InputBox('Mu','Mu (average) : ',FormatFloat('0.00',3.5));
  try
    Mu := StrToFloat(ResStr);
  except
    Mu := 3.5;
  end;
  ResStr := InputBox('Sigma','Sigma (Std.dev.) : ',FormatFloat('0.00',0.1));
  try
    Sigma := StrToFloat(ResStr);
  except
    Sigma := 0.1;
  end;
  XData.RandGauss(Mu,Sigma);
  YData.RandGauss(Mu,Sigma);
  Recalc;
end;

procedure TfrmQQPlot.FormDestroy(Sender: TObject);
begin
  XData.Destroy;
  YData.Destroy;
  X.Destroy;
  Y.Destroy;
  inherited;
end;

procedure TfrmQQPlot.Recalc;
begin
  StatQQPlot(XDAta,YData,X,Y,MinX,MaxX,MinY,MaxY,false,false);
  Series1.MinX := MinX;
  Series1.MaxX := MaxX;
  Series1.MinY := MinY;
  Series1.MaxY := MaxY;
  DrawValues(X,Y,Series1);
end;

initialization
  RegisterClass(TfrmQQPlot);

end.
